﻿// <auto-generated />
using System;
using Dakaris.Database.Context;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Metadata;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;

namespace Dakaris.Database.Migrations
{
    [DbContext(typeof(DakarisContext))]
    partial class DakarisContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "3.1.5")
                .HasAnnotation("Relational:MaxIdentifierLength", 128)
                .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

            modelBuilder.Entity("Dakaris.Model.Domain.Admin", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Email")
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("IsActive")
                        .HasColumnType("bit");

                    b.HasKey("Id");

                    b.ToTable("Admins");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.Complain", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<DateTime>("CreatedAt")
                        .HasColumnType("datetime2");

                    b.Property<string>("Description")
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("IsActive")
                        .HasColumnType("bit");

                    b.Property<long>("ReporteeId")
                        .HasColumnType("bigint");

                    b.Property<long>("ReporterId")
                        .HasColumnType("bigint");

                    b.HasKey("Id");

                    b.HasIndex("ReporteeId");

                    b.HasIndex("ReporterId");

                    b.ToTable("Complains");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.ContactedNurse", b =>
                {
                    b.Property<long>("ContacterId")
                        .HasColumnType("bigint");

                    b.Property<long>("ContacteeId")
                        .HasColumnType("bigint");

                    b.Property<long>("Id")
                        .HasColumnType("bigint");

                    b.HasKey("ContacterId", "ContacteeId");

                    b.HasIndex("ContacteeId");

                    b.ToTable("ContactedNurses");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.GirlyName", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("AvatarUrl")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("GirlyNames");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.Hospital", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("District")
                        .HasColumnType("int");

                    b.Property<bool>("IsActive")
                        .HasColumnType("bit");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.HasKey("Id");

                    b.ToTable("Hospitals");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.Notification", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("ActionButtonLink")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("ActionButtonText")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("HiddenMessage")
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("IsActionButtonAvailable")
                        .HasColumnType("bit");

                    b.Property<bool>("IsDeleted")
                        .HasColumnType("bit");

                    b.Property<bool>("IsRead")
                        .HasColumnType("bit");

                    b.Property<string>("Message")
                        .HasColumnType("nvarchar(max)");

                    b.Property<long>("NurseId")
                        .HasColumnType("bigint");

                    b.Property<DateTime>("Time")
                        .HasColumnType("datetime2");

                    b.HasKey("Id");

                    b.HasIndex("NurseId");

                    b.ToTable("Notifications");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.Nurse", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<int>("AvailableViewCredits")
                        .HasColumnType("int");

                    b.Property<long?>("CurrentHospitalId")
                        .HasColumnType("bigint");

                    b.Property<string>("Email")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("ExtraMobileNo")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("GoogleId")
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("HasPaidForPromo")
                        .HasColumnType("bit");

                    b.Property<bool>("IsActive")
                        .HasColumnType("bit");

                    b.Property<bool>("IsSuspended")
                        .HasColumnType("bit");

                    b.Property<string>("MobileNumber")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("MyPromoCode")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Nic")
                        .HasColumnType("nvarchar(max)");

                    b.Property<long>("PackageId")
                        .HasColumnType("bigint");

                    b.Property<string>("RegisteredPromoCode")
                        .HasColumnType("nvarchar(max)");

                    b.Property<int>("Status")
                        .HasColumnType("int");

                    b.Property<long>("ViewCount")
                        .HasColumnType("bigint");

                    b.HasKey("Id");

                    b.HasIndex("CurrentHospitalId");

                    b.HasIndex("PackageId");

                    b.ToTable("Nurses");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.NurseExpectingHospital", b =>
                {
                    b.Property<long>("NurseId")
                        .HasColumnType("bigint");

                    b.Property<long>("hospitalId")
                        .HasColumnType("bigint");

                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:IdentityIncrement", 1)
                        .HasAnnotation("SqlServer:IdentitySeed", 1)
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.HasKey("NurseId", "hospitalId");

                    b.HasIndex("hospitalId");

                    b.ToTable("NurseExpectingHospitals");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.Package", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<string>("Code")
                        .HasColumnType("nvarchar(max)");

                    b.Property<string>("Description")
                        .HasColumnType("nvarchar(max)");

                    b.Property<bool>("IsActive")
                        .HasColumnType("bit");

                    b.Property<int>("MaxViewCount")
                        .HasColumnType("int");

                    b.Property<string>("Name")
                        .HasColumnType("nvarchar(max)");

                    b.Property<decimal>("Price")
                        .HasColumnType("decimal(18,2)");

                    b.HasKey("Id");

                    b.ToTable("Packages");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.PackageRequest", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasAnnotation("SqlServer:ValueGenerationStrategy", SqlServerValueGenerationStrategy.IdentityColumn);

                    b.Property<long>("NurseId")
                        .HasColumnType("bigint");

                    b.Property<long>("PackageId")
                        .HasColumnType("bigint");

                    b.Property<DateTime>("RequestedAt")
                        .HasColumnType("datetime2");

                    b.Property<int>("Status")
                        .HasColumnType("int");

                    b.HasKey("Id");

                    b.HasIndex("NurseId");

                    b.HasIndex("PackageId");

                    b.ToTable("PackageRequests");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.ViewedNurse", b =>
                {
                    b.Property<long>("ViewerId")
                        .HasColumnType("bigint");

                    b.Property<long>("VieweeId")
                        .HasColumnType("bigint");

                    b.Property<long>("Id")
                        .HasColumnType("bigint");

                    b.HasKey("ViewerId", "VieweeId");

                    b.HasIndex("VieweeId");

                    b.ToTable("ViewedNurses");
                });

            modelBuilder.Entity("Dakaris.Model.Domain.Complain", b =>
                {
                    b.HasOne("Dakaris.Model.Domain.Nurse", "Reportee")
                        .WithMany("ReporteeList")
                        .HasForeignKey("ReporteeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Dakaris.Model.Domain.Nurse", "Reporter")
                        .WithMany("ReporterList")
                        .HasForeignKey("ReporterId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();
                });

            modelBuilder.Entity("Dakaris.Model.Domain.ContactedNurse", b =>
                {
                    b.HasOne("Dakaris.Model.Domain.Nurse", "Contactee")
                        .WithMany("ContacteeList")
                        .HasForeignKey("ContacteeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Dakaris.Model.Domain.Nurse", "Contacter")
                        .WithMany("ContacterList")
                        .HasForeignKey("ContacterId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();
                });

            modelBuilder.Entity("Dakaris.Model.Domain.Notification", b =>
                {
                    b.HasOne("Dakaris.Model.Domain.Nurse", "Nurse")
                        .WithMany("NotificationList")
                        .HasForeignKey("NurseId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Dakaris.Model.Domain.Nurse", b =>
                {
                    b.HasOne("Dakaris.Model.Domain.Hospital", "CurrentHospital")
                        .WithMany("Nurses")
                        .HasForeignKey("CurrentHospitalId")
                        .OnDelete(DeleteBehavior.SetNull);

                    b.HasOne("Dakaris.Model.Domain.Package", "Package")
                        .WithMany("Nurses")
                        .HasForeignKey("PackageId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Dakaris.Model.Domain.NurseExpectingHospital", b =>
                {
                    b.HasOne("Dakaris.Model.Domain.Nurse", "Nurse")
                        .WithMany("NurseExpectingHospitalList")
                        .HasForeignKey("NurseId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Dakaris.Model.Domain.Hospital", "Hospital")
                        .WithMany("NurseExpectingHospitalList")
                        .HasForeignKey("hospitalId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();
                });

            modelBuilder.Entity("Dakaris.Model.Domain.PackageRequest", b =>
                {
                    b.HasOne("Dakaris.Model.Domain.Nurse", "Nurse")
                        .WithMany("PackageRequestList")
                        .HasForeignKey("NurseId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();

                    b.HasOne("Dakaris.Model.Domain.Package", "Package")
                        .WithMany("PackageRequestList")
                        .HasForeignKey("PackageId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();
                });

            modelBuilder.Entity("Dakaris.Model.Domain.ViewedNurse", b =>
                {
                    b.HasOne("Dakaris.Model.Domain.Nurse", "Viewee")
                        .WithMany("VieweeList")
                        .HasForeignKey("VieweeId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("Dakaris.Model.Domain.Nurse", "Viewer")
                        .WithMany("ViewerList")
                        .HasForeignKey("ViewerId")
                        .OnDelete(DeleteBehavior.Restrict)
                        .IsRequired();
                });
#pragma warning restore 612, 618
        }
    }
}
